0%

1. 两数之和

题目

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。 示例: > 给定 nums = [2, 7, 11, 15], target = 9 > 因为 nums[0] + nums[1] = 2 + 7 = 9 > 所以返回 [0, 1]

暴力破解

  • 时间复杂度:O(\(n^2\))
  • 空间复杂度:O(1)
  • 用时 39ms

首先想到了暴力破解的方法,但是后来发现其实没必要遍历整个数组,内部的循环从 0 开始遍历会浪费时间,与将 for(int j = 0; j < len; j++) 改为了 for(int j = i + 1; j < len; j++)

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
class Solution {
public int[] twoSum(int[] nums, int target) {
int len = nums.length;
int[] res ={0, 0};
for(int i = 0; i < len; i++){
for(int j = i + 1; j < len; j++){
if(nums[i] + nums[j] == target){
res[0] = i; res[1] = j;
return res;
}
}
}
return res;
}
}

两遍哈希表

暴力破解的办法时间复杂度较高,还有一种方法可以减少时间复杂度,但是会增加空间复杂度。创建一个 Map 来暂存数据。 - 时间复杂度:O(n) - 空间复杂度:O(n) - 用时 10ms

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
class Solution {
public int[] twoSum(int[] nums, int target) {
Map<Integer, Integer> map = new HashMap<>();
int len = nums.length;
for(int i = 0; i < len; i++){
map.put(nums[i], i);
}
for(int i = 0; i < len; i++){
int diff = target - nums[i];
Integer j = map.get(diff);
if(map.containsKey(diff) && j != i){
return new int[]{i, j};
}
}
throw new ArithmeticException("无解");
}
}

一遍哈希表

  • 时间复杂度:O(n)
  • 空间复杂度:O(n)
  • 用时 6ms

一遍就能做完题目看似不可能,因为看似无法遍历完所有组合,但是实际上可以,只需要仔细思考一下。

1
2
3
4
5
6
7
8
9
10
11
12
13
class Solution {
public int[] twoSum(int[] nums, int target) {
Map<Integer, Integer> map = new HashMap<>();
for(int i = 0; i < nums.length; i++){
int diff = target - nums[i];
if(map.containsKey(diff)){
return new int[] {i, map.get(diff)};
}
map.put(nums[i], i);
}
throw new ArithmeticException("无解");
}
}